/******************** (C) COPYRIGHT 2020 VIVO************************************
* File Name          : pdr_main.h
* Department         : Sensor Algorithm Team
* Current Version    : V2.0
* Author             : zhanli@vivo.com & yuanlin@vivo.cm
* Date of Issued     : 2020.7.18
* Comments           : PDR㷨ƽ̨ļ
********************************************************************************/
#ifdef __cplusplus
extern "C" {
#endif

#ifndef _PDR_MAIN_H_
#define _PDR_MAIN_H_
#include <string>

using namespace std;

#define PATH_MAX  256
#define TRACK_MAX 100000

typedef struct LatLngd {
	double lat;
	double lon;
	double heading;
	double hdop;
	double accuracy;
	double vel;
	double time;
	int    motionType;
} LatLngd;

typedef struct ResultTracks {
	LatLngd gpsTrack[TRACK_MAX];
	LatLngd pdrTrack[TRACK_MAX];
	int gpsLen;
	int pdrLen;
}ResultTracks;

/**----------------------------------------------------------------------
* Function    : pdr_writeKml
* Description : pdr㷨gpspdr켣дΪkmlʽ
*               path    : kmlļļ·
*               name    : kmlļ
*               postfix ƺӵĺ׺ͻ߰汾
* Date        : 2020/11/1 zhanli@vivo.com
*---------------------------------------------------------------------**/
void pdr_writeKml(string path, string name, string postfix);

/**----------------------------------------------------------------------
* Function    : getSimulateFileFp
* Description : ļԼļ·ȡļļָ
* Date        : 2021/01/25 zhanli@vivo.com
*---------------------------------------------------------------------**/
FILE* getSimulateFile(FILE* catalogFp, string path_file, string& fileHead);

/**----------------------------------------------------------------------
* Function    : gpsYaw2GoogleYaw
* Description : ΪkmlʾĽǶȷλҪ0-360˳ʱתYawת
*               Ϊȸֵ֧Yaw
* Date        : 2021/01/25 zhanli@vivo.com
*---------------------------------------------------------------------**/
double gpsYaw2GoogleYaw(double heading);

/**----------------------------------------------------------------------
* Function    : motionType2Str
* Description : û˶תΪַ
* Date        : 2020/8/3 zhanli@vivo.com
*---------------------------------------------------------------------**/
const char* motionType2Str(int type);

/**----------------------------------------------------------------------
* Function    : updateResTrack
* Description : Ľ켣GPS켣PDR켣
* Date        : 2021/01/25 zhanli@vivo.com
*---------------------------------------------------------------------**/
void updateResTrack(ResultTracks& resTrack, lct_fs& lctfs);

#endif

#ifdef __cplusplus
}
#endif
