/******************** (C) COPYRIGHT 2020 Geek************************************
* File Name          : pdr_api.h
* Department         : Sensor Algorithm Team
* Current Version    : V2.0(compare QCOM SAP 5.0)
* Author             : logzhan
* Date of Issued     : 2021.01.26
* Comments           : PDR ⲿӿ
********************************************************************************/
#ifndef _PDR_API_H_
#define _PDR_API_H_

#ifdef __cplusplus
extern "C" {
#endif

/* Header File Including -----------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "pdr_sensor.h"
#include "pdr_base.h"
#include "pdr_util.h"

/* Macro Definition ----------------------------------------------------------*/
#define IMU_LAST_COUNT 10

typedef struct _PosFusion{
	double lat;
	double lon;
	double gpsLat;
	double gpsLon;
	double t;
	int    vaild;
}PosFusion;

/* Function Declaration ------------------------------------------------------*/

/**---------------------------------------------------------------------
* Function    : pdr_algorithmInit
* Description : PDR㷨ʼ̣PDRʼƲ״̬ʼԼ
*               ƽڵĳʼ
* Date        : 2020/7/3 logzhan
*---------------------------------------------------------------------**/
void Algorithm_Init(void);

/**---------------------------------------------------------------------
* Function    : pdr_locationMainLoop
* Description : PDRλѭҪϲĴݲλ
*               ƽڵĳʼ
* Input       : ss_data 
				nmea_data, NMEA
				resultλ
* Output      : int, ־λ
* Date        : 2020/7/3 logzhan
*---------------------------------------------------------------------**/
int LocationMainLoop(imu* ImuData, lct_nmea* NmeaData, lct_fs* LocFusion,
	FILE *fp_gps);

/**---------------------------------------------------------------------
* Function    : pdr_locationMainLoopStr
* Description : PDRλѭҪϲĴݲλ
*               ƽڵĳʼ
* Date        : 2020/07/03 logzhan
*               2020/02/02 logzhan : ӺǷƽ
*---------------------------------------------------------------------**/
int ParseLineAndUpdate(char* line, lct_fs* result);

/**---------------------------------------------------------------------
* Function    : pdr_initRmc
* Description : ʼRMCṹ
* Input       : rmc RMCṹ
* Date        : 2020/7/3 logzhan
*---------------------------------------------------------------------**/
void RMC_Init(lct_nmea_rmc * rmc);

/**---------------------------------------------------------------------
* Function    : pdr_initNmeaFlg
* Description : ʼGPSNMEAЭر־λ
* Input       : ln NMEAṹ
* Date        : 2020/7/3 logzhan
*---------------------------------------------------------------------**/
void NmeaFlag_Init(lct_nmea * ln);

/**---------------------------------------------------------------------
* Function    : clearNmeaFlg
* Description : Nmea־λ,ܺinitͬ
* Date        : 2020/7/4 logzhan
*---------------------------------------------------------------------**/
void ClearNmeaFlg(lct_nmea * ln);

/**---------------------------------------------------------------------
* Function    : pdr_saveGnssInfo
* Description : GPSϢ
* Date        : 2020/7/3 logzhan
*---------------------------------------------------------------------**/
void SaveGnssInfo(lct_nmea* nmea_data, lct_fs* result, FILE* fp_gps);

/**----------------------------------------------------------------------
* Function    : GetLIBVersion
* Description : pdr汾
* Date        : 2020/8/3 logzhan
*---------------------------------------------------------------------**/
const char* GetLIBVersion(void);

/**----------------------------------------------------------------------
* Function    : pdr_closeAlgorithm
* Description : رPDR㷨,ͷԴ
* Date        : 2020/8/3 logzhan
*---------------------------------------------------------------------**/
void Algorithm_DeInit();


#ifdef _WIN32   // Ҫ֧win32ʹãdllӿڵ

/**----------------------------------------------------------------------
* Function    : LibPDR_Init
* Description : ʼPDR㷨(DLL)
* Date        : 2020/8/3 logzhan
*---------------------------------------------------------------------**/
__declspec(dllexport) void LibPDR_Init();

/**----------------------------------------------------------------------
* Function    : PDR_StepUpdateGPS
* Description : GPSִ(DLL)
* Date        : 2022/9/16 logzhan
*---------------------------------------------------------------------**/
__declspec(dllexport) PosFusion LibPDR_StepUpdateGPS(int useGpsFlg);

/**----------------------------------------------------------------------
* Function    : setSimulatorFileCsvPath
* Description : ÷ļ·(DLL)
* Date        : 2020/8/3 logzhan
*---------------------------------------------------------------------**/
__declspec(dllexport) void setSimulatorFileCsvPath(char* path);

/**----------------------------------------------------------------------
* Function    : LibPDR_DeInit
* Description : رpdr㷨ͷڴ棬dll(DLL)
* Date        : 2020/8/3 logzhan
*---------------------------------------------------------------------**/
__declspec(dllexport) void LibPDR_DeInit();

/**----------------------------------------------------------------------
* Function    : setRefGpsYaw
* Description : GPSοǶ
* Date        : 2020/8/3 logzhan
*---------------------------------------------------------------------**/
__declspec(dllexport) void setRefGpsYaw();

#endif

#ifdef __cplusplus
}
#endif

#endif
