#ifdef __cplusplus
extern "C" {
#endif
#ifndef _PARSEDATA_H_
#define _PARSEDATA_H_

#include "pdr_sensor.h"

#define NAEA_LAST_TIME 500
#define IMU_LAST_COUNT 10

#define FLOAT_TO_INT 1000000

/**************************************************************************
* Description : NMEAݺʹݽ
*			  : NMEAݰRMC,GGA,GSA,GSV,Լ׿λϢ
				ݰٶȼƣǣ
**************************************************************************/

    char * strtok_ct(char * s, const char * delim);

/**************************************************************************
* Description : Դ
* Input       : pt ַ
				ts ֻʱms
			    sstp׿дͱʶ
* Output      : imu_p Դṹ
**************************************************************************/
	void ParseIMU(char* pt, IMU_t *imu_p, double ts, int sstp);

/**************************************************************************
* Description : NMEA
* Input       : pt NMEAַ
				ts ֻʱms
* Output      : ln NMEAݽṹ
**************************************************************************/
	void parseNMEA(char* pt, Nmea_t *ln, double ts);

/**************************************************************************
* Description : GGAЭ
* Input       : pt NMEAַ
				ts ֻʱms
* Output      : ln NMEAݽṹ
**************************************************************************/
	void ParseGGA(char* pt, Nmea_t *ln, double ts);

/**************************************************************************
* Description : RMCЭ
* Input       : pt NMEAַ
				ts ֻʱms
* Output      : ln NMEAݽṹ
**************************************************************************/
	void ParseRMC(char* pt, Nmea_t *ln, double ts);

/**************************************************************************
* Description : GSVЭ
* Input       : pt NMEAַ
				ts ֻʱms
* Output      : ln NMEAݽṹ
**************************************************************************/
	void parseGSV(char* pt, Nmea_t *ln, double ts);

/**************************************************************************
* Description : GSAЭ
* Input       : pt NMEAַ
				ts ֻʱms
* Output      : ln NMEAݽṹ
**************************************************************************/
	void ParseGSA(char* pt, Nmea_t *ln, double ts);

/**----------------------------------------------------------------------
* Function    : parseLocAccuracy
* Description : GPSAccuracyȲ
* Date        : 2020/7/9 yuanlin@vivo.com &logzhan
*---------------------------------------------------------------------**/
void parseLocAccuracy(char* pt, Nmea_t *ln, double ts);

/**************************************************************************
* Description : NMEAǷ
* Input       : ln NMEAݽṹ
**************************************************************************/
void preprocessNMEA(Nmea_t *ln);

int ParseLineStr(char* line, IMU_t* imu_p, Nmea_t* ln);

/**----------------------------------------------------------------------
* Function    : HexToDec
* Description : ʮתΪʮ
* Date        : 2022-09-15 logzhan
*---------------------------------------------------------------------**/
long HexToDec(char *source);

/**----------------------------------------------------------------------
* Function    : pdr_int2Hex
* Description : ʮתΪʮ
* Date        : 2020/7/9 yuanlin@vivo.com & logzhan
*---------------------------------------------------------------------**/
char * Int2Hex(int a, char *buffer);


/**----------------------------------------------------------------------
* Function    : pdr_getIndexOfSigns
* Description : chַsignе
* Date        : 2020/7/9 yuanlin@vivo.com &logzhan
*---------------------------------------------------------------------**/
	int pdr_getIndexOfSigns(char ch);
#endif
#ifdef __cplusplus
}
#endif