/******************** (C) COPYRIGHT 2022 Geek************************************
* File Name          : Complex.c
* Current Version    : V2.0
* Author             : logzhan
* Date of Issued     : 2022.10.15
* Comments           : PDR֧
********************************************************************************/
/* Header File Including -----------------------------------------------------*/
#include "math.h"
#include "Complex.h"

/**---------------------------------------------------------------------
* Function    : ComplexAbs
* Description : ֵ
* Date        : 2022/10/15 logzhan
*---------------------------------------------------------------------**/
float ComplexAbs(Complex_t c) {
    return (float)sqrt(c.real * c.real + c.image * c.image);
}

/**---------------------------------------------------------------------
* Function    : ComplexAdd
* Description : ӷ
* Date        : 2022/10/15 logzhan
*---------------------------------------------------------------------**/
Complex_t ComplexAdd(Complex_t a, Complex_t b) {
    Complex_t c = { 0 };
    c.real = a.real + b.real;
    c.image = a.image + b.image;
    return c;
}

/**---------------------------------------------------------------------
* Function    : ComplexSub
* Description : 
* Date        : 2022/10/15 logzhan
*---------------------------------------------------------------------**/
Complex_t ComplexSub(Complex_t a, Complex_t b) {
    Complex_t c = { 0 };

    c.real = a.real - b.real;
    c.image = a.image - b.image;

    return c;
}

/**---------------------------------------------------------------------
* Function    : ComplexMul
* Description : ˷
* Date        : 2022/10/15 logzhan
*---------------------------------------------------------------------**/
Complex_t ComplexMul(Complex_t a, Complex_t b) {
    Complex_t c;
    c.real = a.real * b.real - a.image * b.image;
    c.image = a.real * b.image + a.image * b.real;
    return c;
}

/**---------------------------------------------------------------------
* Function    : ComplexPow
* Description : ָ
* Date        : 2022/10/15 logzhan
*---------------------------------------------------------------------**/
Complex_t ComplexPow(Complex_t c, int n) {
    Complex_t p = { 1, 0 };
    int i;
    float real;
    for (i = 0; i < n; ++i) {
        real = p.real * c.real - p.image * c.image;
        p.image = p.real * c.image + p.image * c.real;
        p.real = real;
    }
    return p;
}