/******************** (C) COPYRIGHT 2020 Geek************************************
* File Name          : pdr_api.h
* Department         : Sensor Algorithm Team
* Current Version    : V2.0(compare QCOM SAP 5.0)
* Author             : logzhan
* Date of Issued     : 2021.01.26
* Comments           : PDR ⲿӿ
********************************************************************************/
#ifndef _PDR_API_H_
#define _PDR_API_H_

#ifdef __cplusplus
extern "C" {
#endif

/* Header File Including -----------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "pdr_sensor.h"
#include "PDRBase.h"
#include "Utils.h"

/* Macro Definition ----------------------------------------------------------*/
#define IMU_LAST_COUNT 10

typedef struct _PosFusion{
	double lat;
	double lon;
	double gpsLat;
	double gpsLon;
	double t;
	int    vaild;
}PosFusion;

/* Function Declaration ------------------------------------------------------*/

/**---------------------------------------------------------------------
* Function    : Algorithm_Init
* Description : PDR㷨ʼ̣PDRʼƲ״̬ʼԼ
*               ƽڵĳʼ
* Date        : 2022/10/15 logzhan
*---------------------------------------------------------------------**/
void Algorithm_Init(void);

/**---------------------------------------------------------------------
* Function    : PDRLocationMainLoop
* Description : PDRλѭҪϲĴݲλ
*               ƽڵĳʼ
* Date        : 2022/10/16 logzhan
*---------------------------------------------------------------------**/
int PDRLocationMainLoop(IMU_t* ImuData, Nmea_t* NmeaData, LctFs_t* LocFusion);

/**---------------------------------------------------------------------
* Function    : pdr_locationMainLoopStr
* Description : PDRλѭҪϲĴݲλ
*               ƽڵĳʼ
* Date        : 2020/07/03 logzhan
*               2020/02/02 logzhan : ӺǷƽ
*---------------------------------------------------------------------**/
int ParseDataAndUpdate(char* line, LctFs_t* result);

/**---------------------------------------------------------------------
* Function    : pdr_initRmc
* Description : ʼRMCṹ
* Input       : rmc RMCṹ
* Date        : 2020/7/3 logzhan
*---------------------------------------------------------------------**/
void RMC_Init(NmeaRMC_t * rmc);

/**---------------------------------------------------------------------
* Function    : pdr_initNmeaFlg
* Description : ʼGPSNMEAЭر־λ
* Input       : ln NMEAṹ
* Date        : 2020/7/3 logzhan
*---------------------------------------------------------------------**/
void NmeaFlag_Init(Nmea_t * ln);

/**---------------------------------------------------------------------
* Function    : clearNmeaFlg
* Description : Nmea־λ,ܺinitͬ
* Date        : 2020/7/4 logzhan
*---------------------------------------------------------------------**/
void ClearNmeaFlg(Nmea_t * ln);

/**---------------------------------------------------------------------
* Function    : pdr_saveGnssInfo
* Description : GPSϢ
* Date        : 2020/7/3 logzhan
*---------------------------------------------------------------------**/
void SaveGnssInfo(Nmea_t* nmea_data, LctFs_t* result, FILE* fp_gps);

/**----------------------------------------------------------------------
* Function    : GetPDRVersion
* Description : ȡpdr汾
* Date        : 2022/10/15 logzhan
*---------------------------------------------------------------------**/
const char* GetPDRVersion(void);

/**----------------------------------------------------------------------
* Function    : pdr_closeAlgorithm
* Description : رPDR㷨,ͷԴ
* Date        : 2020/8/3 logzhan
*---------------------------------------------------------------------**/
void Algorithm_DeInit();


#ifdef _WIN32   // Ҫ֧win32ʹãdllӿڵ

/**----------------------------------------------------------------------
* Function    : LibPDR_Init
* Description : ʼPDR㷨(DLL)
* Date        : 2020/8/3 logzhan
*---------------------------------------------------------------------**/
__declspec(dllexport) void LibPDR_Init();

/**----------------------------------------------------------------------
* Function    : PDR_StepUpdateGPS
* Description : GPSִ(DLL)
* Date        : 2022/9/16 logzhan
*---------------------------------------------------------------------**/
__declspec(dllexport) PosFusion LibPDR_StepUpdateGPS(int useGpsFlg);

/**----------------------------------------------------------------------
* Function    : setSimulatorFileCsvPath
* Description : ÷ļ·(DLL)
* Date        : 2020/8/3 logzhan
*---------------------------------------------------------------------**/
__declspec(dllexport) void setSimulatorFileCsvPath(char* path);

/**----------------------------------------------------------------------
* Function    : LibPDR_DeInit
* Description : رpdr㷨ͷڴ棬dll(DLL)
* Date        : 2020/8/3 logzhan
*---------------------------------------------------------------------**/
__declspec(dllexport) void LibPDR_DeInit();

/**----------------------------------------------------------------------
* Function    : setRefGpsYaw
* Description : GPSοǶ
* Date        : 2020/8/3 logzhan
*---------------------------------------------------------------------**/
__declspec(dllexport) void setRefGpsYaw();

#endif

#ifdef __cplusplus
}
#endif

#endif
