/******************** (C) COPYRIGHT 2022 Geek************************************
* File Name          : Filter.c
* Current Version    : V2.0
* Author             : logzhan
* Date of Issued     : 2022.10.15
* Comments           : PDR˲ֿ֧
********************************************************************************/
/* Header File Including ------------------------------------------------------*/
#ifndef __FILTER_H__
#define __FILTER_H__
/* Macro Declaration ----------------------------------------------------------*/
#define FILTER_MAX_LENGTH              71

/* Structure Declaration ------------------------------------------------------*/
typedef struct Filter_t {              // iir or fir filter
    int    reset;                      // reset flag
    int    order;                      // coefficient array length, not filter order
    double H0;                         // dc signal gain
    double b[FILTER_MAX_LENGTH];       // b coefficient
    double a[FILTER_MAX_LENGTH];       // a coefficient
    double yout[FILTER_MAX_LENGTH];    // yout buffer
    double xin[FILTER_MAX_LENGTH];     // xin buffer
} Filter_t;

/* Function Declaration -------------------------------------------------------*/

/**---------------------------------------------------------------------
* Function    : FilterReset
* Description : ˲
* Date        : 2022/10/15 logzhan
*---------------------------------------------------------------------**/
void FilterReset(Filter_t *f);

/**---------------------------------------------------------------------
* Function    : FilterSetCoef
* Description : ˲ò
* Input       : order      coefficient array length, not filter order
*               *b         b coefficient
*               *a         a coefficient
*               H0         dc signal gain
* Date        : 2022/10/15 logzhan
*---------------------------------------------------------------------**/
void FilterSetCoef(Filter_t *f, int order, double *b, double *a, double H0);

/**---------------------------------------------------------------------
* Function    : FilterFilter
* Description : ˲˲
* Date        : 2022/10/15 logzhan
*---------------------------------------------------------------------**/
double FilterFilter(Filter_t *f, double x);

#endif
