#ifndef __DETECTOR_H
#define __DETECTOR_H

#ifdef __cplusplus
extern "C" {
#endif

/* Header File Including ------------------------------------------------------------------------ */
#include <stdint.h>
#include <stdlib.h>
#include <time.h>
#include "PDRBase.h"
#include "buffer.h"
#include "AHRS.h"

/* Macro Declaration ---------------------------------------------------------------------------- */
#define DETECTOR_NO_ERROR           0
#define DETECTOR_OUT_OF_MEMORY      1

#define MAG_BUF_LEN                 256
#define MAG_LEN                     6

/* Struct Declaration --------------------------------------------------------------------------- */


typedef void (*DETECTOR_update_callback)(Detector_t *detector);

/* Global Variable Declaration ------------------------------------------------------------------ */
extern BUFFER_SHORT g_acc_frq_buf[3];
extern BUFFER_SHORT g_acc_amp_buf[3];
extern BUFFER_SHORT g_gyr_frq_buf[3];
extern BUFFER_SHORT g_gyr_amp_buf[3];

/* Function Declaration ------------------------------------------------------------------------- */

/**---------------------------------------------------------------------
* Function    : GetDetectorObj
* Description : ȡPDR˶
* Date        : 2020/02/16 logzhan
*---------------------------------------------------------------------**/
Detector_t *GetDetectorObj(void);

/**---------------------------------------------------------------------
* Function    : Detector_Init
* Description : ʼ˶ʶûһ˶ģʽ
* Date        : 2022/09/23 logzhan 
*---------------------------------------------------------------------**/
Detector_t* Detector_Init(void);

/**---------------------------------------------------------------------
* Function    : DetectorReset
* Description : PDR˶
* Date        : 2022/09/23 logzhan
*---------------------------------------------------------------------**/
void DetectorReset(void);

/**---------------------------------------------------------------------
* Function    : DetectMotionType
* Description : pdr˶ͼ
* Date        : 2020/7/20 
*---------------------------------------------------------------------**/
int DetectMotionType(void);

/**---------------------------------------------------------------------
* Function    : predict
* Description : жֻЯʽֳֵֹ֡ȣ
* Date        : 2020/7/20 logzhan
*---------------------------------------------------------------------**/
int pdr_detectorPredict(float* feature);


/**----------------------------------------------------------------------
* Function    : DetUserStatic
* Description : ûǷھֹ״̬
* Date        : 2022/10/15 logzhan
*---------------------------------------------------------------------**/
int DetUserStatic(PDR_t* g_pdr, GNSS_t* pgnss, unsigned long delSteps);

/**----------------------------------------------------------------------
* Function    : detIsCarMode
* Description : ʶǷǳģʽ
* Input       : pgnssGPSݽṹ
				g_pdrPDRṹ
				delSteps ϴȲı仯
				time
* Output      : intģʽ־λ
* Date        : 2021/01/28 logzhan
*---------------------------------------------------------------------**/
int DetectCarMode(GNSS_t* pgnss, PDR_t* g_pdr, unsigned long delSteps, int* time);

/**----------------------------------------------------------------------
* Function    : detPdrToReset
* Description : PDRϵͳǷҪãǵPDRʧ󣬻
*               PDRGPSλá
* Date        : 2021/01/28 logzhan
*---------------------------------------------------------------------**/
int DetectPdrToReset(double pdr_angle, int* gpscnt, unsigned long deltsteps, PDR_t* g_pdr);

/**---------------------------------------------------------------------
* Function    : DetectorUpdateIMU
* Description : ˶ͼimuϢһʱ
*               û˶
* Date        : 2022/09/23
*---------------------------------------------------------------------**/
void DetectorUpdateIMU(IMU_t* imu, PDR_t* pdr);

#ifdef __cplusplus
}
#endif

#endif
