#ifdef __cplusplus
extern "C" {
#endif
#ifndef _PARSEDATA_H_
#define _PARSEDATA_H_

#include "pdr_sensor.h"

#define NAEA_LAST_TIME 500
#define IMU_LAST_COUNT 10

#define FLOAT_TO_INT 1000000

/**************************************************************************
* Description : NMEAݺʹݽ
*			  : NMEAݰRMC,GGA,GSA,GSV,Լ׿λϢ
				ݰٶȼƣǣ
**************************************************************************/

    char * strtok_ct(char * s, const char * delim);

/**************************************************************************
* Description : Դ
* Input       : pt ַ
				ts ֻʱms
			    sstp׿дͱʶ
* Output      : imu_p Դṹ
**************************************************************************/
	void parseIMU(char* pt, imu *imu_p, double ts, int sstp);

/**************************************************************************
* Description : NMEA
* Input       : pt NMEAַ
				ts ֻʱms
* Output      : ln NMEAݽṹ
**************************************************************************/
	void parseNMEA(char* pt, lct_nmea *ln, double ts);

/**************************************************************************
* Description : GGAЭ
* Input       : pt NMEAַ
				ts ֻʱms
* Output      : ln NMEAݽṹ
**************************************************************************/
	void parseGGA(char* pt, lct_nmea *ln, double ts);

/**************************************************************************
* Description : RMCЭ
* Input       : pt NMEAַ
				ts ֻʱms
* Output      : ln NMEAݽṹ
**************************************************************************/
	void parseRMC(char* pt, lct_nmea *ln, double ts);

/**************************************************************************
* Description : GSVЭ
* Input       : pt NMEAַ
				ts ֻʱms
* Output      : ln NMEAݽṹ
**************************************************************************/
	void parseGSV(char* pt, lct_nmea *ln, double ts);

/**************************************************************************
* Description : GSAЭ
* Input       : pt NMEAַ
				ts ֻʱms
* Output      : ln NMEAݽṹ
**************************************************************************/
	void parseGSA(char* pt, lct_nmea *ln, double ts);

/**----------------------------------------------------------------------
* Function    : parseLocAccuracy
* Description : GPSAccuracyȲ
* Date        : 2020/7/9 yuanlin@vivo.com &zhanli@vivo.com
*---------------------------------------------------------------------**/
void parseLocAccuracy(char* pt, lct_nmea *ln, double ts);

/**************************************************************************
* Description : NMEAǷ
* Input       : ln NMEAݽṹ
**************************************************************************/
void preprocessNMEA(lct_nmea *ln);

int pdr_parseLineStr(char* line, imu* imu_p, lct_nmea* ln);

/**----------------------------------------------------------------------
* Function    : pdr_hexToDec
* Description : ʮתΪʮ
* Date        : 2020/7/9 zhanli@vivo.com
*---------------------------------------------------------------------**/
long pdr_hexToDec(char *source);

/**----------------------------------------------------------------------
* Function    : pdr_int2Hex
* Description : ʮתΪʮ
* Date        : 2020/7/9 yuanlin@vivo.com & zhanli@vivo.com
*---------------------------------------------------------------------**/
char * pdr_int2Hex(int a, char *buffer);


/**----------------------------------------------------------------------
* Function    : pdr_getIndexOfSigns
* Description : chַsignе
* Date        : 2020/7/9 yuanlin@vivo.com &zhanli@vivo.com
*---------------------------------------------------------------------**/
	int pdr_getIndexOfSigns(char ch);
#endif
#ifdef __cplusplus
}
#endif