/******************** (C) COPYRIGHT 2020 VIVO************************************
* File Name          : matrix.c
* Department         : Sensor Algorithm Team
* Current Version    : V2.0(compare QCOM SAP 5.0)
* Author             : yuanlin_rjyb@vivo.com & zhanli@vivo.com
* Date of Issued     : 2021.01.29
* Comments           : PDR֧
*                      2021/02/16 zhanli@vivo.com : ûо֤
*                      ܴ󲻴ڵ⣬ҪŻͨжϽ
*                      治ڵ
********************************************************************************/
/* Header File Including -----------------------------------------------------*/
#include "pdr_matrix.h"

/**---------------------------------------------------------------------
* Function    : m_trans
* Description : ת
* Date        : 2020/02/10 yuanlin_rjyb@vivo.com & zhanli@vivo.com
*---------------------------------------------------------------------**/
void m_trans(double a[N][N], double r[N][N]) {
	int i, j;
	for (i = 0; i < N; i++) {
		for (j = 0; j < N; j++) {
			r[i][j] = a[j][i];
		}
	}
}

/**---------------------------------------------------------------------
* Function    : vm_mlt
* Description : ; r = b * a
* Date        : 2020/02/10 yuanlin_rjyb@vivo.com & zhanli@vivo.com
*---------------------------------------------------------------------**/
void vm_mlt(double a[N], double b[N][N], double r[N]) {
	int i, j;
	double temp[N] = { 0.0 };
	//for (i = 0; i < N; i++) {
	//	temp[i] = a[i];
	//}
	for (i = 0; i < N; i++) {
		for (j = 0; j < N; j++) {
			temp[i] += ((b[i][j] * 100) * (a[j] * 100)) / 10000;
		}
	}
	for (i = 0; i < N; i++) {
		r[i] = temp[i];
	}

}

/**---------------------------------------------------------------------
* Function    : mm_mlt
* Description : ; r = a * b
* Date        : 2020/02/10 yuanlin_rjyb@vivo.com & zhanli@vivo.com
*---------------------------------------------------------------------**/
void mm_mlt(double a[N][N], double b[N][N], double r[N][N]) {
	int i, j, m;
	double temp[N][N] = { { 0.0 } };
	for (i = 0; i < N; i++) {
		for (j = 0; j < N; j++) {
			for (m = 0; m < N; m++) {
				//temp[i][j] += a[j][m] * b[m][j];
				temp[i][j] += a[i][m] * b[m][j];
			}
		}
	}

	for (i = 0; i < N; i++) {
		for (j = 0; j < N; j++) {
			r[i][j] = temp[i][j];
		}
	}
}

/**---------------------------------------------------------------------
* Function    : m_add
* Description : ; r = a + b, ע֧a = a + b
* Date        : 2020/02/10 yuanlin_rjyb@vivo.com & zhanli@vivo.com
*---------------------------------------------------------------------**/
void m_add(double a[N][N], double b[N][N], double r[N][N]) {
	int i, j;
	for (i = 0; i < N; i++) {
		for (j = 0; j < N; j++) {
			r[i][j] = a[i][j] + b[i][j];
		}
	}
}


/**---------------------------------------------------------------------
* Function    : v_add
* Description :  r = a + b, ע֧a = a + b
* Date        : 2020/02/10 yuanlin_rjyb@vivo.com & zhanli@vivo.com
*---------------------------------------------------------------------**/
void v_add(double a[N], double b[N], double r[N]) {
	int i;
	for (i = 0; i < N; i++) {
		r[i] = a[i] + b[i];
	}
}

/**---------------------------------------------------------------------
* Function    : m_sub
* Description : ; r = a - b, ע֧a = a - b
* Date        : 2020/02/10 yuanlin_rjyb@vivo.com & zhanli@vivo.com
*---------------------------------------------------------------------**/
void m_sub(double a[N][N], double b[N][N], double r[N][N]) {
	int i, j;
	for (i = 0; i < N; i++) {
		for (j = 0; j < N; j++) {
			r[i][j] = a[i][j] - b[i][j];
		}
	}
}
/**---------------------------------------------------------------------
* Function    : v_sub
* Description :  r = a - b, ע֧a = a - b
* Date        : 2020/02/10 yuanlin_rjyb@vivo.com & zhanli@vivo.com
*---------------------------------------------------------------------**/
void v_sub(double a[N], double b[N], double r[N]) {
	int i;
	for (i = 0; i < N; i++) {
		r[i] = a[i] - b[i];
	}

}

/**---------------------------------------------------------------------
* Function    : m_inverse
* Description : 
* Date        : 2020/02/10 yuanlin_rjyb@vivo.com & zhanli@vivo.com
*---------------------------------------------------------------------**/
void m_inverse(double(*a)[N], double (*a_inverse)[N]) {

	double l[N][N] = { { 0.0 } };
	double u[N][N] = { { 0.0 } };
	double l_inverse[N][N] = { { 0.0 } };
	double u_inverse[N][N] = { { 0.0 } };
	double temp[N][N] = { { 0.0 } };

	int i, j, k;
	double s;

	for (i = 0; i < N; i++)l[i][i] = 1;

	for (i = 0; i < N; i++){
		for (j = i; j <N; j++){
			s = 0;
			for (k = 0; k < i; k++){
				s += l[i][k] * u[k][j];
			}
			u[i][j] = a[i][j] - s;
		}
		for (j = i + 1; j < N; j++){
			s = 0;
			for (k = 0; k < i; k++){
				s += l[j][k] * u[k][i];
			}
			l[j][i] = (a[j][i] - s) / u[i][i];
		}
	}
	for (i = 0; i < N; i++)l_inverse[i][i] = 1;

	for (i = 1; i < N; i++){
		for (j = 0; j < i; j++){
			s = 0;
			for (k = 0; k < i; k++){
				s += l[i][k] * l_inverse[k][j];
			}
			l_inverse[i][j] = -s;
		}
	}
	for (i = 0; i < N; i++){
		u_inverse[i][i] = 1 / u[i][i];
	}
	for (i = 1; i < N; i++)
	{
		for (j = i - 1; j >= 0; j--)
		{
			s = 0;
			for (k = j + 1; k <= i; k++)
			{
				s += u[j][k] * u_inverse[k][i];
			}
			u_inverse[j][i] = -s / u[j][j];
		}
	}
	for (i = 0; i < N; i++){
		for (j = 0; j < N; j++){
			for (k = 0; k < N; k++){
				temp[i][j] += u_inverse[i][k] * l_inverse[k][j];
			}
		}
	}
	for (i = 0; i < N; i++) {
		for (j = 0; j < N; j++) {
			a_inverse[i][j] = temp[i][j];
		}
	}
}